Unit GSU1R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure GSU1R(var ISEED :Integer; N :Integer; var R :Array of Real); 

implementation

procedure GSU1R(var ISEED :Integer; N :Integer; var R :Array of Real);
var
{ v1,v2,v3 :integer; }
I :Integer;
Z :Extended;
const
D2P31M :Extended = 2147483647.0e0;
D2PN31 :Extended = 4.656612873077393e-10;
D2P32M :Integer = 16807;
label
_1;
begin
Z := (ISEED);
for I:=1 to N do
 begin
{   v1 := Trunc(D2P32M*Z); }
{   v2 := Trunc(D2P31M); }
{   v3 := v1 mod v2; }
{   z := v3; }
{   Z := (Trunc(D2P32M*Z) Mod Trunc(D2P31M)); }
  Z := Emod(D2P32M*Z,D2P31M);
_1:
  R[I-1] := Z*D2PN31;
 end;
ISEED := Trunc( Z );
end;

end.
